diff --git a/philosophy/surveillance-vs-democracy.pt-br.po b/philosophy/surveillance-vs-democracy.pt-br.po
index 0d5e755..ed8f7a2 100644
--- a/philosophy/surveillance-vs-democracy.pt-br.po
+++ b/philosophy/surveillance-vs-democracy.pt-br.po
@@ -1,7 +1,7 @@
 # Brazilian Portuguese translation of http://www.gnu.org/philosophy/surveillance-vs-democracy.html
 # Copyright (C) 2017 Free Software Foundation, Inc.
 # This file is distributed under the same license as the original article.
-# Rafael Fontenelle <rafaelff@gnome.org>, 2016, 2017.
+# Rafael Fontenelle <rafaelff@gnome.org>, 2016, 2017, 2018.
 # Paulo Francisco Slomp <slomp@ufrgs.br>, 2016. (proofread)
 # Daniel Pimentel <d4n1@d4n1.org>, 2017. (proofread)
 # André Phellip Ferreira <werewolf@cyberdude.com>, 2017. (proofread)
@@ -9,7 +9,7 @@ msgid ""
 msgstr ""
 "Project-Id-Version: surveillance-vs-democracy.html\n"
 "POT-Creation-Date: 2018-01-13 15:55+0000\n"
-"PO-Revision-Date: 2017-12-29 18:45-0200\n"
+"PO-Revision-Date: 2018-01-22 17:29-0200\n"
 "Last-Translator: Rafael Fontenelle <rafaelff@gnome.org>\n"
 "Language-Team: Brazilian Portuguese <www-pt-br-general@gnu.org>\n"
 "Language: pt_BR\n"
@@ -18,6 +18,7 @@ msgstr ""
 "Content-Transfer-Encoding: 8bit\n"
 "Plural-Forms: nplurals=2; plural=(n > 1);\n"
 "X-Generator: Virtaal 1.0.0-beta1\n"
+"X-Outdated-Since: 2018-01-01 05:59+0000\n"
 
 #. type: Content of: <title>
 msgid ""
@@ -247,6 +248,13 @@ msgid ""
 "a>.  These rules are not seriously meant to be obeyed; rather, they are a "
 "fairy-tale we can believe if we like."
 msgstr ""
+"Na prática, não podemos nem mesmo esperar que as agências estaduais criem  "
+"desculpas para satisfazer as regras para o uso de dados de vigilância &ndash;"
+" porque as agências dos EUA já <a href=\"https://theintercept.com/2018/01/09"
+"/dark-side-fbi-dea-illegal-searches-secret-evidence/\"> mentiram para "
+"encobrir a quebra das regras</a>. Essas regras não são seriamente feitas "
+"para serem obedecidas; em vez disso, eles são um conto de fadas que podemos "
+"acreditar se quisermos."
 
 #. type: Content of: <div><div><p>
 msgid ""
@@ -655,21 +663,21 @@ msgid ""
 "many of those companies misuse the data directly or provide it to data "
 "brokers."
 msgstr ""
-"A NSA, por meio do software de vigilância PRISM, <a href=\"https://www."
-"commondreams.org/headline/2013/08/23-2\">conseguiu entrar nas bases de dados "
-"de muitas grandes corporações da Internet</a>. AT&amp;T guardou todos os "
-"seus registros de chamada telefônica desde 1987 e <a href=\"http://www."
-"nytimes.com/2013/09/02/us/drug-agents-use-vast-phone-trove-eclipsing-nsas."
-"html?_r=0\">disponibiliza para o DEA</a> para pesquisa sob demanda. "
-"Estritamente falando, o governo dos EUA não possui aqueles dados, mas em "
-"termos práticos ele pode acessá-los mesmo assim. Algumas empresas são "
+"A NSA, por meio do software de vigilância PRISM, <a href=\""
+"https://www.commondreams.org/headline/2013/08/23-2\">conseguiu entrar nas "
+"bases de dados de muitas grandes corporações da Internet</a>. AT&amp;T "
+"guardou todos os seus registros de chamada telefônica desde 1987 e <a href=\""
+"http://www.nytimes.com/2013/09/02/us/drug-agents-use-vast-phone-trove-"
+"eclipsing-nsas.html?_r=0\">disponibiliza para o DEA</a> para pesquisa sob "
+"demanda. Estritamente falando, o governo dos EUA não possui aqueles dados, "
+"mas em termos práticos ele pode acessá-los mesmo assim. Algumas empresas são "
 "elogiadas por <a href=\"https://www.eff.org/who-has-your-back-government-"
 "data-requests-2015\">resistirem a requisições de dados do governo até a "
 "extensão limitada que eles podem</a>, mas que pode apenas parcialmente "
 "compensar o dano que eles causam por coletar tais dados, em primeiro lugar. "
 "Adicionalmente, muitas dessas empresas fazem mau uso dos dados diretamente "
-"ou os fornecem para <i>data brokers“</i><sup><a href=\"#TransNote3\">3</a></"
-"sup>."
+"ou os fornecem para <i>data brokers</i><sup><a href=\"#TransNote3\""
+">3</a></sup>."
 
 #. type: Content of: <div><div><p>
 msgid ""
@@ -703,7 +711,7 @@ msgstr ""
 "usuários e tendências. Isso converte um mero incômodo — propaganda que nós "
 "podemos aprender a ignorar — em um sistema de vigilância que nos prejudica, "
 "nós sabendo ou não. Compras pela Internet também rastreiam seus usuários. E "
-"todos nós estamos sabendo que ”políticas de privacidade“ são mais desculpas "
+"todos nós estamos sabendo que “políticas de privacidade” são mais desculpas "
 "para violação de privacidade do que compromisso de cumprimento."
 
 #. type: Content of: <div><div><p>
@@ -1096,13 +1104,13 @@ msgstr ""
 "<b>Nota do tradutor</b>:\n"
 "<ol>\n"
 "<li id=\"TransNote1\"><i>FISA</i> é o acrônimo para <i>Foreign Intelligence "
-"Surveillance Act</i> (<a href=\"https://pt.wikipedia.org/wiki/Lei_de_Vigil"
-"%C3%A2ncia_de_Intelig%C3%AAncia_Estrangeira\">Lei de Vigilância de "
-"Inteligência Estrangeira</a>), sendo que <i>FISA court</i>, ou <i>FISC</i>, "
-"é a corte que supervisiona requerimentos relacionados ao uso desta lei. "
-"(fonte: <a href=\"https://en.wikipedia.org/wiki/"
-"Foreign_Intelligence_Surveillance_Act#FISA_court\">Wikipédia</a>, data: 04 "
-"de julho de 2016)</li>\n"
+"Surveillance Act</i> (<a href=\""
+"https://pt.wikipedia.org/wiki/Lei_de_Vigil%C3%A2ncia_de_Intelig%C3%"
+"AAncia_Estrangeira\">Lei de Vigilância de Inteligência Estrangeira</a>), "
+"sendo que <i>FISA court</i>, ou <i>FISC</i>, é a corte que supervisiona "
+"requerimentos relacionados ao uso desta lei. (fonte: <a href=\""
+"https://en.wikipedia.org/wiki/Foreign_Intelligence_Surveillance_Act#"
+"FISA_court\">Wikipédia</a>, data: 04 de julho de 2016)</li>\n"
 "<li id=\"TransNote2\"><i>LOVEINT</i> é o nome dado à prática, pelos "
 "funcionários dos serviços de inteligência americana de fazerem uso dos "
 "recursos de monitoramento da NSA para espionar pessoas de seus interesses "
@@ -1110,28 +1118,28 @@ msgstr ""
 "LOVEINT\">Wikipédia</a>, data: 04 de Julho de 2016)</li>\n"
 "<li id=\"TransNote3\">Um <i>data broker</i> é uma entidade que se dedica a "
 "compilar e a vender informação de consumidores na Internet, vendendo essa "
-"informação a outras organizações. (fonte: <a href=\"https://pt.wikipedia.org/"
-"wiki/Data_broker\">Wikipédia</a>, data: 04 de julho de 2016)</li>\n"
+"informação a outras organizações. (fonte: <a href=\""
+"https://pt.wikipedia.org/wiki/Data_broker\">Wikipédia</a>, data: 04 de julho "
+"de 2016)</li>\n"
 "<li id=\"TransNote4\"><i>testilying</i> é um jogo de palavras entre "
 "<i>testify</i> (testemunhar) e <i>lying</i> (mentir), referindo-se à prática "
 "de falso testemunho utilizada pelos policiais para criar provas contra o "
-"indivíduo (fonte: <a href=\"https://en.wikipedia.org/wiki/Police_perjury"
-"\">Wikipédia</a>, data: 05 de julho de 2016)</li>\n"
+"indivíduo (fonte: <a href=\"https://en.wikipedia.org/wiki/Police_perjury\""
+">Wikipédia</a>, data: 05 de julho de 2016)</li>\n"
 "<li id=\"TransNote5\">A explicação do espaço em branco em “PAT RIOT” foi "
 "dada por Richard Stallman em sua entrevista em 12 de novembro de 2012 a "
-"Hacker Public Radio (Ver <a href=\"/philosophy/speeches-and-interview.html"
-"\">Discursos e Entrevistas</a>). Exatamente aos 1h 13' 40“, ele deixou "
-"registrado o motivo pelo qual não se pode chamar tal ato de ”Ato "
-"Patriótico“ (USA Patriot): o título completo do Ato em questão é <i>Uniting "
-"and Strengthening America by Providing Appropriate Tools Required to "
-"Intercept and Obstruct Terrorism Act</i> (em português, ato de união e "
-"fortalecimento fornecendo ferramentas necessárias e apropriadas para "
-"interceptar e obstruir terrorismo), abreviada sob o acrônimo ”USAPATRIOT "
-"Act“; por se tratar de um acrônimo, temos todo o direito de dividir entre P."
-"A.T. e R.I.O.T., o que muda a pronúncia e evita a referência a patriotismo. "
-"Acrescentando que, <i>riot</i> significa ”revolta“ e <i>Pat riot</i> faz "
-"referência ao grito da torcida da equipe de futebol americano de Boston, os "
-"<i>Pats</i>.</li>\n"
+"Hacker Public Radio (Ver <a href=\"/philosophy/speeches-and-interview.html\">"
+"Discursos e Entrevistas</a>). Exatamente aos 1h 13' 40\", ele deixou "
+"registrado o motivo pelo qual não se pode chamar tal ato de “Ato Patriótico” "
+"(USA Patriot): o título completo do Ato em questão é <i>Uniting and "
+"Strengthening America by Providing Appropriate Tools Required to Intercept "
+"and Obstruct Terrorism Act</i> (em português, ato de união e fortalecimento "
+"fornecendo ferramentas necessárias e apropriadas para interceptar e obstruir "
+"terrorismo), abreviada sob o acrônimo “USAPATRIOT Act”; por se tratar de um "
+"acrônimo, temos todo o direito de dividir entre P.A.T. e R.I.O.T., o que "
+"muda a pronúncia e evita a referência a patriotismo. Acrescentando que, "
+"<i>riot</i> significa “revolta” e <i>Pat riot</i> faz referência ao grito da "
+"torcida da equipe de futebol americano de Boston, os <i>Pats</i>.</li>\n"
 "</ol>"
 
 # type: Content of: <div><p>
@@ -1176,11 +1184,9 @@ msgstr ""
 "envio de traduções das páginas desse site."
 
 #. type: Content of: <div><p>
-# | Copyright &copy; 2015, 2016, [-2017-] {+2017, 2018+} Richard Stallman
-#, fuzzy
 #| msgid "Copyright &copy; 2015, 2016, 2017 Richard Stallman"
 msgid "Copyright &copy; 2015, 2016, 2017, 2018 Richard Stallman"
-msgstr "Copyright &copy; 2015, 2016, 2017 Richard Stallman"
+msgstr "Copyright &copy; 2015, 2016, 2017, 2018 Richard Stallman"
 
 #. type: Content of: <div><p>
 msgid ""