Index: find/testsuite/find.gnu/access.exp
===================================================================
RCS file: /cvsroot/findutils/findutils/find/testsuite/find.gnu/access.exp,v
retrieving revision 1.3
diff -u -p -r1.3 access.exp
--- find/testsuite/find.gnu/access.exp	19 Apr 2007 09:36:07 -0000	1.3
+++ find/testsuite/find.gnu/access.exp	22 Apr 2007 11:11:48 -0000
@@ -7,7 +7,7 @@ if [ file readable tmp/000 ] {
     # On Cygwin, a user with admin rights can read all files, and 
     # access(foo,R_OK) correctly returns 1 for all files.
     warning "You have superuser privileges, skipping this test."
-3    untested {skipping this test because you have superuser privileges}
+    untested {skipping this test because you have superuser privileges}
 } else {
     touch tmp/x tmp/w tmp/r tmp/rw tmp/rwx tmp/0 
     exec chmod 400 tmp/r